'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BASE_CLASS = 'sui-MoleculeCollapsible';
var CONTENT_CLASS = BASE_CLASS + '-content';
var CONTAINER_BUTTON_CLASS = BASE_CLASS + '-container';
var COLLAPSED_CLASS = 'is-collapsed';
var BUTTON_CLASS = BASE_CLASS + '-btn';
var ICON_CLASS = BASE_CLASS + '-icon';
var MIN_HEIGHT = 100; // px

var MoleculeCollapsible = function (_Component) {
  (0, _inherits3.default)(MoleculeCollapsible, _Component);

  function MoleculeCollapsible(props) {
    (0, _classCallCheck3.default)(this, MoleculeCollapsible);

    var _this = (0, _possibleConstructorReturn3.default)(this, (MoleculeCollapsible.__proto__ || (0, _getPrototypeOf2.default)(MoleculeCollapsible)).call(this, props));

    _this.toggleCollapse = function () {
      var _this$state = _this.state,
          collapsed = _this$state.collapsed,
          showButton = _this$state.showButton;
      var _this$props = _this.props,
          onClose = _this$props.onClose,
          onOpen = _this$props.onOpen;

      if (showButton) {
        _this.setState({ collapsed: !collapsed });collapsed && onOpen() || onClose();
      }
    };

    _this.childrenContainer = _react2.default.createRef();
    _this.state = { collapsed: true, showButton: true };
    return _this;
  }

  (0, _createClass3.default)(MoleculeCollapsible, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var offsetHeight = this.childrenContainer.current.offsetHeight;
      this.setState({ showButton: offsetHeight >= this.props.height });
    }
  }, {
    key: 'render',
    value: function render() {
      var _cx, _cx3;

      var _state = this.state,
          collapsed = _state.collapsed,
          showButton = _state.showButton;
      var _props = this.props,
          children = _props.children,
          height = _props.height,
          icon = _props.icon,
          showText = _props.showText,
          hideText = _props.hideText,
          hasGradient = _props.hasGradient;

      var wrapperClassName = (0, _classnames2.default)('' + BASE_CLASS, (_cx = {}, (0, _defineProperty3.default)(_cx, BASE_CLASS + '--withGradient', hasGradient), (0, _defineProperty3.default)(_cx, COLLAPSED_CLASS, collapsed), _cx));
      var iconClassName = (0, _classnames2.default)('' + ICON_CLASS, (0, _defineProperty3.default)({}, COLLAPSED_CLASS, collapsed));
      var containerClassName = (0, _classnames2.default)('' + CONTAINER_BUTTON_CLASS, (_cx3 = {}, (0, _defineProperty3.default)(_cx3, CONTAINER_BUTTON_CLASS + '--withGradient', hasGradient), (0, _defineProperty3.default)(_cx3, COLLAPSED_CLASS, collapsed), _cx3));
      var containerHeight = showButton && collapsed ? height + 'px' : 'none';

      return _react2.default.createElement(
        'div',
        { className: wrapperClassName },
        _react2.default.createElement(
          'div',
          {
            className: CONTENT_CLASS,
            style: { maxHeight: '' + containerHeight },
            ref: this.childrenContainer
          },
          children
        ),
        showButton && _react2.default.createElement(
          'div',
          { className: containerClassName },
          _react2.default.createElement(
            'button',
            {
              type: 'button',
              className: BUTTON_CLASS,
              onClick: this.toggleCollapse
            },
            collapsed ? showText : hideText,
            _react2.default.createElement(
              'span',
              { className: iconClassName },
              icon
            )
          )
        )
      );
    }
  }]);
  return MoleculeCollapsible;
}(_react.Component);

MoleculeCollapsible.displayName = 'MoleculeCollapsible';

MoleculeCollapsible.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /**
   * Content to collapse
   */
  children: _propTypes2.default.node.isRequired,
  /**
   * Define the min height visible
   */
  height: _propTypes2.default.number,
  /**
   * Icon to be added on the right of the content
   */
  icon: _propTypes2.default.node.isRequired,
  /**
   * Text to show when content is collapsed
   */
  showText: _propTypes2.default.string.isRequired,
  /**
   * Text to show when content is not collapsed
   */
  hideText: _propTypes2.default.string.isRequired,
  /**
   * Activate/deactivate gradient
   */
  hasGradient: _propTypes2.default.bool,
  /**
   * On open callback
   */
  onOpen: _propTypes2.default.func,
  /**
   * On close callback
   */
  onClose: _propTypes2.default.func
} : {} : {};

MoleculeCollapsible.defaultProps = {
  height: MIN_HEIGHT,
  hasGradient: true,
  onOpen: function onOpen() {},
  onClose: function onClose() {}
};

exports.default = MoleculeCollapsible;